/*  Variable pour utiliser les dépendances  */
var express = require('express');
var app = express();
var ejs = require('ejs');
var mongoose = require("mongoose");
var bodyParser = require("body-parser");

/*  Methode pour utliser les posts  */
app.use(bodyParser.urlencoded({ extended: true }));

/*  Méthode pour utiliser le css  */
app.use(express.static(__dirname + '/public'));

var db = mongoose.connect("mongodb://127.0.0.1:27017/mydb");
//var db = mongoose.connect("mongodb://192.168.0.25:27017/AGIpc");

/*  Tester la connection à MongodB*/
mongoose.connection.on("error", function(){
  console.log("Erreur de connexion à la base de donnée");
  console.log("------------------------------");
});

mongoose.connection.on("open", function(){
  console.log("Connexion  réussie à la base de donnée");
  console.log("------------------------------");
});

/*  Le Schéma à utiliser pour utiliser la base  */
var releveSchema = mongoose.Schema({
  age: Number,
  horodate : String,
  vomi : Number,
  sechbucc : Number,
  doulbucc : Number,
  aphtes : Number,
  temperature : Number,
  mg : Number,
  poids : Number,
  taille : Number,
  fatigue : Number
});

var patientSchema = mongoose.Schema({
  id : Number,
  nom : String,
  prenom : String,
  releve : [releveSchema]
});

var Patient = mongoose.model("Patient", patientSchema);

/*  URL */
//  Page d'accueil
app.get('/', function (req, res) {
    res.render("index.ejs");
}); 

//  Page pour afficher le choix des patients
/* Génère des liens cliquables pour choisir le patient */
app.get('/patients', function (req, res) {
  Patient.find(function(err, patients){
    if(err) { throw err; }
    res.render("patients.ejs",{patients});
  });
});

app.get('/patients/new/', function (req, res) {
  Patient.find(function(err, patients){
    if(err) { throw err; }
    res.render("new.ejs");
  });
});


app.post('/patients', function patients_test(req, res, next){
  _nom = req.body.nom;
  _prenom = req.body.prenom;
  _action = req.body.Action;
  _id = parseInt(req.body.id);
  
  console.log(req.body.nom);
  next();
  },
  function getpatient(req, res, next) {
    if(_action=="add")
      {
        NewPatient = new Patient({id:(_id+1),nom:_nom,prenom:_prenom,age:null});
        NewPatient.save();
        next();
      }
    if(_action=="modify")
      {
        Patient.update({id:_id},{nom:_nom,prenom:_prenom},function(err,numberAffected){
          next();
        });
      }
  },
  function affichagePatient(req, res, next) {
    Patient.find(function(err,patients) {
      res.render("patients.ejs",{patients});
    });
  }
);

app.post('/patients/edit', function (req, res) {
  modify_id = req.body.edit;
  //console.log(modify_id);

  Patient.findOne({id:modify_id},function(err,patient){
    if(err) { throw err; }
    res.render("modify.ejs",{patient});
  });
});

app.get('/patients/:numId', function(req,res){
  var del_id = req.params.numId;

  Patient.remove({id:del_id},function(err, countRemoved){
    Patient.find(function(err,patients){
      if(err) { throw err; }
      res.render("patients.ejs",{patients});
    });
  });
});

//  Page pour afficher les patients en tableau
/* Récupère l'id du patient */
app.get('/patients/show/:numPatient', function (req, res) {
  numPatient = req.params.numPatient;
  Patient.findOne( {id:numPatient} ,function(err, patients){
    if(err) { throw err;}
    //console.log(patients);
    res.render("show.ejs",{patients});
  });
});


app.get('/add/', function (req, res) {
  Question.find(function(err, question){
    if(err) { throw err; }
    res.render("question.ejs",{
      titre : "Liste des questions",
      question
    });
  });
});

// Démarrer le serveur
app.listen(3000);